--- musl.o/src/network/inet_ntop.c
+++ musl/src/network/inet_ntop.c
@@ -18,14 +18,25 @@
 			return s;
 		break;
 	case AF_INET6:
+		memset(buf, 0, sizeof buf);
+		i = (!memcmp(a, buf, 10) &&
+		((a[10] == 0 && a[11] == 0) || (a[10] == 255 && a[11] == 255))) ? 1 : 0;
 		memset(buf, 'x', sizeof buf);
 		buf[sizeof buf-1]=0;
-		snprintf(buf, sizeof buf,
-			"%x:%x:%x:%x:%x:%x:%x:%x",
-			256*a[0]+a[1],256*a[2]+a[3],
-			256*a[4]+a[5],256*a[6]+a[7],
-			256*a[8]+a[9],256*a[10]+a[11],
-			256*a[12]+a[13],256*a[14]+a[15]);
+		if (i)
+			snprintf(buf, sizeof buf,
+				"%x:%x:%x:%x:%x:%x:%d.%d.%d.%d",
+				256*a[0]+a[1],256*a[2]+a[3],
+				256*a[4]+a[5],256*a[6]+a[7],
+				256*a[8]+a[9],256*a[10]+a[11],
+				a[12],a[13],a[14],a[15]);
+		else
+			snprintf(buf, sizeof buf,
+				"%x:%x:%x:%x:%x:%x:%x:%x",
+				256*a[0]+a[1],256*a[2]+a[3],
+				256*a[4]+a[5],256*a[6]+a[7],
+				256*a[8]+a[9],256*a[10]+a[11],
+				256*a[12]+a[13],256*a[14]+a[15]);
 		/* Replace longest /(^0|:)[:0]{2,}/ with "::" */
 		for (i=best=0, max=2; buf[i]; i++) {
 			if (i && buf[i] != ':') continue;
